diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -29,7 +29,18 @@
  * GNU General Public License for more details (www.gnu.org).
  * 
  */
+#ifdef __sgi
+# ifdef _XOPEN_SOURCE
+#  if ((_XOPEN_SOURCE+0) < 520)
+#    define _XOPEN_SOURCE 520
+#  endif
+# else
+#  define _XOPEN_SOURCE 520
+# endif
+#endif
 #include <stdio.h>
+/* Above added by Allen to try to make sure vsnprintf (for SaveSprintf) returns needed length
+   - may need to be limited in what applies to (needed for SGI IRIX at minimum) */
 #include <stdlib.h>
 #include <time.h>
 #include <math.h>
@@ -52,6 +63,16 @@
 #include <assert.h>
 #endif
 
+#if (defined(__GNUC__) || defined(_ISOC99_SOURCE) || defined(__sgi) || defined(_SVID3) || defined(_XOPEN4UX) || (defined(_XOPEN_SOURCE) && defined(_XOPEN_SOURCE_EXTENDED) && (_XOPEN_SOURCE_EXTENDED >= 1)))
+#define HAVE_CBRT
+#endif
+
+#if defined(HAVE_CBRT)
+#define CBRT(x) cbrt((double)(x))
+#else
+#define CBRT(x) pow((double)(x),(double)(1.0/3.0))
+#endif
+
 #if defined(WIN_VERSION) && !defined(__GNUC__)
 #define VISUAL
 #endif
@@ -112,6 +133,7 @@
 
 /* debugging compiler statements */
 #undef	DEBUG_COMPRESSDATA
+#define DEBUG_COMPRESSDATA2 /* - Allen */
 #undef	DEBUG_ADDDUMMYCHARS
 #undef	DEBUG_CREATEPARSMATRIX
 #undef	DEBUG_SETUPTERMSTATE
@@ -118,11 +140,13 @@
 #undef	DEBUG_INITCHAINCONDLIKES
 #undef	DEBUG_SETCHAINPARAMS
 #undef	DEBUG_BUILDSTARTTREE
+#undef  DEBUG_DEROOT_USER_TREE /* -Allen */
 #undef	DEBUG_RUNCHAIN
 #undef	DEBUG_NOSHORTCUTS
 #undef	DEBUG_NOSCALING
 #undef	DEBUG_LOCAL
 #undef	DEBUG_SPRCLOCK
+#undef  DEBUG_SCALER_NAN /* - Allen */
 #undef	DEBUG_TIPROBS_STD
 #undef	DEBUG_RUN_WITHOUT_DATA
 #undef	DEBUG_UNROOTED_SLIDER
@@ -132,6 +156,12 @@
 #undef  DEBUG_CSLIDER
 #undef  DEBUG_ExtSPRClock
 #undef  DEBUG_TREEHEIGHT
+#undef  DEBUG_MPI /* - Allen */
+
+
+#if !(defined(DEBUG_NOSCALING) || defined(NO_ALTSCALING))
+#define ALTSCALING /* do scaling only in response to LIKE_EPSILON - Allen */
+#endif
 
 /* local (to this file) data types */
 typedef struct pfnode
@@ -188,14 +218,14 @@
 #		endif
 int	    CondLikeRoot_NY98 (TreeNode *p, int division, int chain);
 int     CondLikeRoot_Std (TreeNode *p, int division, int chain);
-int	    CondLikeScaler_Gen (TreeNode *p, int division, int chain);
+int	    CondLikeScaler_Gen (TreeNode *p, int division, int chain, int do_full_scaling);
 #		if !defined (FAST_LOG)
-int	    CondLikeScaler_NUC4 (TreeNode *p, int division, int chain);
+int	    CondLikeScaler_NUC4 (TreeNode *p, int division, int chain, int do_full_scaling);
 #		else
-int	    CondLikeScaler_NUC4_fast (TreeNode *p, int division, int chain);
+int	    CondLikeScaler_NUC4_fast (TreeNode *p, int division, int chain, int do_full_scaling);
 #		endif
-int	    CondLikeScaler_NY98 (TreeNode *p, int division, int chain);
-int     CondLikeScaler_Std (TreeNode *p, int division, int chain);
+int	    CondLikeScaler_NY98 (TreeNode *p, int division, int chain, int do_full_scaling);
+int     CondLikeScaler_Std (TreeNode *p, int division, int chain, int do_full_scaling);
 int     CondLikeUp_Bin (TreeNode *p, int division, int chain);
 int     CondLikeUp_Gen (TreeNode *p, int division, int chain);
 int     CondLikeUp_NUC4 (TreeNode *p, int division, int chain);
@@ -303,6 +333,7 @@
 int     Move_NNI (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
 int		Move_NNI_Hetero (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
 int		Move_NodeSlider (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
+int		Move_NodeSlider2 (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
 int		Move_NodeSliderClock (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
 int     Move_Omega (Param *param, int chain, long *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
 int     Move_Omega_M (Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
@@ -356,7 +387,7 @@
 int     PrintTermState (void);
 void	PrintTiProbs (MrBFlt *tP, MrBFlt *bs, int nStates);
 int     PrintTopConvInfo (void);
-void    PrintToScreen (int curGen, time_t endingT, time_t startingT);
+void    PrintToScreen (int curGen, int movesAccepted, time_t endingT, time_t startingT);
 /* void    PrintToScreen (int curGen, clock_t endingT, clock_t startingT);*/
 int     PrintTree (int curGen, Tree *tree);
 int     ProcessStdChars (void);
@@ -372,7 +403,9 @@
 int     RemoveTreeSamples (int from, int to);
 int     ReopenMBPrintFiles (void);
 int     RequestAbortRun(void);
+#if !defined(ALTSCALING)
 int     ResetScalers (void);
+#endif
 int     RunChain (long int *seed);
 int     SaveSprintf(char **target, int *targetLen, char *fmt, ...);
 int     SetAARates (void);
@@ -457,7 +490,7 @@
 long int		*compMatrix;		         /* compressed character matrix					 */
 long int		*parsMatrix = NULL;		         /* parsimony (bitset) matrix for terminals  	 */
 long int		*parsSets = NULL;					 /* parsimony (bitset) matrix for int nodes 	 */
-CLFlt			*numSitesOfPat;		         /* no. sites of each pattern					 */
+CLFlt2			*numSitesOfPat;		         /* no. sites of each pattern					 */
 CLFlt			*termCondLikes = NULL;		         /* cond likes for terminals                     */
 CLFlt			*chainCondLikes;	         /* cond likes for chains						 */
 int				condLikeRowSize;	         /* row size of cond like matrices				 */
@@ -488,8 +521,8 @@
 CLFlt			**treeScaler;		         /* pointers to tree scalers for each chain		 */
 CLFlt			*nodeScalerSpace;	         /* space holding cond like node scalers         */
 CLFlt			**nodeScaler;		         /* pointers to cond like scalers for each chain */
-CLFlt			*tiProbSpace;		         /* space holding tiProbs						 */
-CLFlt			**tiProbs;			         /* pointers to tiProbs for each chain			 */
+CLFlt2			*tiProbSpace;		         /* space holding tiProbs						 */
+CLFlt2			**tiProbs;			         /* pointers to tiProbs for each chain			 */
 int				cijkRowSize;		         /* row size of cijk information                 */
 MrBFlt			*cijkSpace;			         /* space holding cijk information               */
 MrBFlt			**cijks;			         /* pointers to cijk for each chain              */
@@ -548,6 +581,45 @@
 int				highestLocalRunId;			 /* highest local run Id                         */
 #endif
 
+/* debugging scaler problems - Allen */
+
+#if defined(ALTSCALING)
+int had_like_epsilon = 0;
+int did_scaling = 0;
+#endif
+
+#define SCALER_WARN_THRESH 40.0
+#define SCALER_WARN_THRESH2 39.0
+ /* 16 =~ -log(1/2**23) */
+#define SCALER_WARN_THRESH3 16.0
+#define CL_WARN_THRESH 1.000001
+#define CL_WARN_THRESH2 2.0
+#define CL_WARN_THRESH3 20.0
+
+#define LOG_CL_WARN_THRESH 0.000001
+
+#define MAX_TIMES_CL_WARN 200
+int num_times_cl_warn = 0; /* count of num times warned */
+
+#define MAX_TIMES_SCALER_WARN 200
+int num_times_scaler_warn = 0;
+
+#define MAX_TIMES_SCALER_WARN2 200
+int num_times_scaler_warn2 = 0;
+
+#define MAX_TIMES_SCALER_WARN3 20
+int num_times_scaler_warn3 = 0; /* this is reset w/each likelihood print */
+
+#define MAX_TIMES_SCALER_WARN4 200
+int num_times_scaler_warn4 = 0;
+
+int num_times_scaler_adjusted = 0;
+/* only incremented if lnScaler would be above LIKE_EPSILON, scaler above CL_WARN_THRESH */
+int num_times_scaler_adjusted_big = 0;
+
+int num_times_scaler_adjusted2 = 0;
+/* only incremented if lnScaler would be above log(CL_WARN_THRESH) */
+int num_times_scaler_adjusted2_big = 0;
 
 /*-----------------------------------------------------------------------
 |
@@ -562,7 +634,7 @@
 				newRowSize, numDummyChars, newColumn, newChar, oldColumn, oldChar, 
 				isCompat, *tempChar, numIncompatibleChars;
 	long		*tempMatrix;
-	CLFlt		*tempSitesOfPat;
+	CLFlt2		*tempSitesOfPat;
 	ModelInfo	*m;
 	ModelParams	*mp;
 	CharInfo	cinfo;
@@ -627,7 +699,7 @@
 
 	/* allocate space for new data */
 	tempMatrix = (long *) calloc (numLocalTaxa * newRowSize, sizeof(long));
-	tempSitesOfPat = (CLFlt *) calloc (numCompressedChars, sizeof(CLFlt));
+	tempSitesOfPat = (CLFlt2 *) calloc (numCompressedChars, sizeof(CLFlt2));
 	tempChar = (int *) calloc (compMatrixRowSize, sizeof(int));
 	if (!tempMatrix || !tempSitesOfPat || !tempChar)
 		{
@@ -1138,7 +1210,10 @@
 	/* the number will be corrected further down for unbalanced scenarios */
 	numChainsForProc = (int) (chainParams.numChains * chainParams.numRuns / num_procs);
 
+#       if defined(DEBUG_MPI)
+	MrBayesPrint("%s   Attempting swap of %d and %d\n",spacer,swapA,swapB);
 #	endif
+#	endif
 
 	/* are we using character reweighting? */
 	reweightingChars = NO;
@@ -1365,6 +1440,9 @@
 					{
 					return (ERROR);
 					}
+#       if defined(DEBUG_MPI)
+				MrBayesPrint ("%s   Waiting on swap communication (A)\n",spacer);
+#       endif
 				ierror = MPI_Waitall (2, request, status);
 				if (ierror != MPI_SUCCESS)
 					{
@@ -1456,6 +1534,10 @@
 					{
 					return (ERROR);
 					}
+#       if defined(DEBUG_MPI)
+
+				MrBayesPrint ("%s   Waiting on swap communication (B)\n",spacer);
+#       endif
 				ierror = MPI_Waitall (2, request, status);
 				if (ierror != MPI_SUCCESS)
 					{
@@ -1904,7 +1986,7 @@
 
 	int				i, j, whichNde, n, *tempNums, numAvailTips, intNodeNum, whichElement, 
 					nLongsNeeded;
-	MrBFlt			sum, oldBls[5], newBls[5], tempLength, depth;
+	MrBFlt			sum=0.0, oldBls[5], newBls[5], tempLength, depth;
 	TreeNode		*p, *q, *up, *dn, *a, *b, *c;
 	PolyTree		constraintTree;
 	Tree			*tempTree;
@@ -2337,9 +2419,20 @@
 		CopyToTreeFromTree (tempTree, userTree);
 
 		/* If unrooted tree is needed and usertree is rooted, we unroot it */
-		if (t->isRooted == NO && tempTree->isRooted == YES)
-			{
+		if (t->isRooted == NO && tempTree->isRooted == YES) {
+#if (defined(DEBUG_BUILDSTARTTREE) || defined(DEBUG_DEROOT_USER_TREE)) /* Allen */
+		  if (ShowMCMCTree(tempTree) == ERROR) {
+		    MrBayesPrint("%s   Problem showing rooted tempTree\n",
+				 spacer);
+		  }
+#endif
 			DerootTree (tempTree, outGroupNum);
+#if (defined(DEBUG_BUILDSTARTTREE) || defined(DEBUG_DEROOT_USER_TREE)) /* Allen */
+		  if (ShowMCMCTree(tempTree) == ERROR) {
+		    MrBayesPrint("%s   Problem showing derooted tempTree\n",
+				 spacer);
+		  }
+#endif
 			}
 
 		/* Make sure calculation root is in right place if tree is unrooted */
@@ -2349,9 +2442,12 @@
 			}
 
 		/* Prune tree if some taxa are deleted from this analysis */
-		if (PruneTree (tempTree) == ERROR)
-			{
+		if (PruneTree (tempTree) == ERROR) {
 			MrBayesPrint ("%s   Error in pruning user tree\n", spacer);
+		  if (ShowMCMCTree(tempTree) == ERROR) { /* Allen */
+		    MrBayesPrint("%s   Problem showing tempTree w/error\n",
+				 spacer);
+		  }
 			goto errorExit;
 			}
 			
@@ -2403,12 +2499,14 @@
 				goto errorExit;
 				}
 			for (i=0; i<chainParams.numStartPerts; i++)
-				{
+				{ /* removed _&&_ p->anc->anc == NULL from below -
+				     was not obeying constraints with perturbations - Allen */
 				do
 					{
 					whichElement = (int)(RandomNumber(seed) * t->nIntNodes);
 					p = t->intDownPass[whichElement];
-					} while (p->anc->anc == NULL && p->isLocked == YES);
+					} while ((p->isLocked == YES) || (p->anc == NULL) ||
+						 (p->anc->anc == NULL));
 				q = p->anc;
 				a  = p->left;
 				b  = p->right;
@@ -2420,6 +2518,7 @@
 					{
 					c  = q->left;
 					}
+				if ((t->isRooted != NO) || (userBrlensDef == YES)) /* - Allen */
 				sum = a->length + b->length + c->length + p->length + q->length;
 				if (RandomNumber(seed) < 0.5)
 					{
@@ -2449,8 +2548,13 @@
 					q->right = a;
 					a->anc  = q;
 					}
-				if (sum > 0.0)
-					{
+				if ((t->isRooted == NO) && (userBrlensDef != YES)) { /* - Allen */
+				  a->length = 0.1;
+				  b->length = 0.1;
+				  c->length = 0.1;
+				  p->length = 0.1;
+				  q->length = 0.1;
+				} else if (sum > (BRLENS_MIN*5)) { /* - Allen */
 					/* We also need to change the branch lengths. However, we don't
 					   change the overall tree length this way. */
 					oldBls[0] = a->length / sum;
@@ -2464,8 +2568,19 @@
 					c->length = newBls[2] * sum;
 					p->length = newBls[3] * sum;
 					q->length = newBls[4] * sum;
+					if (t->isRooted == NO) { /* otherwise, tree length a problem... */
+					  if (a->length < BRLENS_MIN) /* roundoff error, usually - Allen */
+					    a->length = BRLENS_MIN;
+					  if (b->length < BRLENS_MIN)
+					    b->length = BRLENS_MIN;
+					  if (c->length < BRLENS_MIN)
+					    c->length = BRLENS_MIN;
+					  if (p->length < BRLENS_MIN)
+					    p->length = BRLENS_MIN;
+					  if (q->length < BRLENS_MIN)
+					    q->length = BRLENS_MIN;
 					}
-				else
+				} else
 					{
 					a->length = BRLENS_MIN;
 					b->length = BRLENS_MIN;
@@ -2698,7 +2813,7 @@
 		posit = m->rateProbStart + (compCharPos[c] - m->compCharStart) * m->numGammaCats;
 				
 		/* calculate the HMM forward probs fi(x) at site x in HMM */
-		if (siteJump[c] <= MAX_SMALL_JUMP)
+		if ((siteJump[c] > 0) && (siteJump[c] <= MAX_SMALL_JUMP)) /* added siteJump[c] > 0 check - Allen */
 			{
 			max = 0.0;
 			for (i=0; i<nRates; i++)
@@ -2711,7 +2826,7 @@
 					max = F[i];
 				}
 			}
-		else if (siteJump[c] < BIG_JUMP)	/* intermediate jump, calculate trans probs */
+		else if ((siteJump[c] > 0) && (siteJump[c] < BIG_JUMP))	/* intermediate jump, calculate trans probs */
 			{
 			MultiplyMatrixNTimes(nRates, markovTi[0], siteJump[c], markovTiN);
 			max = 0.0;
@@ -3053,7 +3168,7 @@
 
 {
 
-	int				a, b, i, j, k, nLongsNeeded;
+	int				a, b, i, j, k, nLongsNeeded, did_flip;
 	long int		*constraintPartition, *mask, *bitsets;
 	TreeNode		*p=NULL;
 	   	
@@ -3061,7 +3176,7 @@
 	nLongsNeeded = (numLocalTaxa / nBitsInALong) + 1;
 
 	bitsets = (long int *) calloc ((t->nNodes + 1)*nLongsNeeded + /*1*/
-                                       1+numLocalTaxa/nBitsInALong+1, 
+                                       1+numLocalTaxa/nBitsInALong+1, /* exactly what is this trying to add?!? - Allen */
                                        sizeof(long int));
 
 	if (!bitsets)
@@ -3102,11 +3217,12 @@
 			}
 		}
 
-	for (a=b=0; a<numDefinedConstraints; a++)
-		{
+	for (a=b=0; a<numDefinedConstraints; a++) {
 		if (t->constraints[a] == NO)
 			continue;
 
+		did_flip = 0;
+
 		/* set bits in partition to add */
 		for (j=0; j<nLongsNeeded; j++)
 			constraintPartition[j] = 0;
@@ -3121,8 +3237,10 @@
 			}
 
 		/* make sure outgroup is outside constrained partition if unrooted tree */
-		if (t->isRooted == NO && IsBitSet(localOutGroup, constraintPartition))
+		if (t->isRooted == NO && IsBitSet(localOutGroup, constraintPartition)) {
 			FlipBits(constraintPartition, nLongsNeeded, mask);
+			did_flip = 1;
+		}
 
 		/* find the locked node */
 		for (i=j=0; i<t->nNodes; i++)
@@ -3136,17 +3254,18 @@
 	
 		if (j != 1)
 			{
-			MrBayesPrint ("%s   Lock number %d is not set or set several places\n", spacer, b);
+			MrBayesPrint ("%s   Lock number %d is not set or set several places (%d)\n", spacer, b, j);
 			goto errorExit;
 			}
 
 		/* check that locked node is correct */
-		for (i=0; i<nLongsNeeded; i++)
-			{
-			if (p->partition[i] != constraintPartition[i]) 
-				{
-				MrBayesPrint ("%s   Lock number %d is set for the wrong node\n", spacer, b);
+		for (i=0; i<nLongsNeeded; i++) {
+		  if (p->partition[i] != constraintPartition[i]) {
+		    MrBayesPrint ("%s   Lock number %d is set for the wrong node (%ld vs %ld; did_flip %d)\n", spacer, b,
+				  p->partition[i], constraintPartition[i], did_flip); /* - Allen */
+#ifdef DEBUG_CONSTRAINTS
 				goto errorExit;
+#endif
 				}
 			}
 
@@ -3573,6 +3692,7 @@
 				{
 				foundIt = YES;
 				p->lockID = b;
+				p->isLocked = YES; /* Allen */
 				if (t->isCalibrated == YES)
 					{
 					p->isDated = YES;
@@ -3604,9 +3724,24 @@
 int CheckTemperature (void)
 
 {
-
+  if ((chainParams.useSA == YES) && (chainParams.numChains > 1)) { /* - Allen */
+    MrBayesPrint ("%s   Cannot use Simulated Annealing with multiple (%d) chains.\n",
+		  spacer, chainParams.numChains);
+    return (ERROR);
+  }
+  if ((chainParams.useAdapt == YES) && (chainParams.numChains > 1)) { /* - Allen */
+    MrBayesPrint ("%s   Cannot use Adapt with multiple (%d) chains.\n",
+		  spacer, chainParams.numChains);
+    return (ERROR);
+  }
+  if ((chainParams.useAdapt == YES) && (chainParams.numRuns > 1)) { /* - Allen */
+    MrBayesPrint ("%s   Cannot use Adapt with multiple (%d) runs.\n",
+		  spacer, chainParams.numRuns);
+    return (ERROR);
+  }
 	if (chainParams.userDefinedTemps == YES)
 	        {
+
 		  if(AreDoublesEqual(chainParams.userTemps[0], 1.0, ETA)==NO)
 			{
 			MrBayesPrint ("%s   The first user-defined temperature must be 1.0.\n", spacer);
@@ -3737,8 +3872,10 @@
 #	if defined DEBUG_COMPRESSDATA
 	if (PrintMatrix() == ERROR)
 		goto errorExit;
+#       if (! defined(MPI_ENABLED))
 	getchar();
 #	endif
+#	endif
 
 	/* set all pointers that will be allocated locally to NULL */
 	isTaken = NULL;
@@ -3961,6 +4098,9 @@
 
 	compMatrixRowSize = newColumn;
 
+	MrBayesPrint("%s   Have %d unique site patterns total\n", spacer, 
+		     numCompressedChars); /* - Allen */
+
 	/* now we know the size, so we can allocate space for the compressed matrix ... */
 	if (memAllocs[ALLOC_COMPMATRIX] == YES)
 		{
@@ -3980,10 +4120,10 @@
 		MrBayesPrint ("%s   numSitesOfPat not free in CompressData\n", spacer);
 		goto errorExit;
 		}
-	numSitesOfPat = (CLFlt *) calloc (numCompressedChars, sizeof(CLFlt));
+	numSitesOfPat = (CLFlt2 *) calloc (numCompressedChars, sizeof(CLFlt2));
 	if (!numSitesOfPat)
 		{
-		MrBayesPrint ("%s   Problem allocating numSitesOfPat (%d)\n", spacer, numCompressedChars * sizeof(MrBFlt));
+		MrBayesPrint ("%s   Problem allocating numSitesOfPat (%d)\n", spacer, numCompressedChars * sizeof(CLFlt2));
 		goto errorExit;
 		}
 	memAllocs[ALLOC_NUMSITESOFPAT] = YES;
@@ -4007,16 +4147,18 @@
 			compMatrix[pos(i,j,compMatrixRowSize)] = tempMatrix[pos(i,j,numLocalChar)];
 
 	for (i=0; i<numCompressedChars; i++)
-		numSitesOfPat[i] = (CLFlt) tempSitesOfPat[i];
+		numSitesOfPat[i] = (CLFlt2) tempSitesOfPat[i];
 
 	for (i=0; i<compMatrixRowSize; i++)
 		origChar[i] = tempChar[i];
 
-#	if defined (DEBUG_COMPRESSDATA)
+#	if (defined(DEBUG_COMPRESSDATA) || defined(DEBUG_COMPRESSDATA2)) /* - Allen */
 	if (PrintCompMatrix() == ERROR)
 		goto errorExit;
+#       if (! defined(MPI_ENABLED))
 	getchar();
 #	endif
+#	endif
 
 	/* free the temporary variables */
 	free (tempSitesOfPat);
@@ -4055,7 +4197,8 @@
 {
 
 	int				c, k;
-	CLFlt			*clL, *clR, *clP, *pL, *pR, *tiPL, *tiPR;
+	CLFlt			*clL, *clR, *clP;
+	CLFlt2                  *pL, *pR, *tiPL, *tiPR;
 	ModelInfo		*m;
 	
 	/* find model settings for this division */
@@ -4109,7 +4252,8 @@
 
 	int				a, b, c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL, catStart,
 					nObsStates, nStates, nStatesSquared, preLikeJump;
-	CLFlt			likeL, likeR, *pL, *pR, *tiPL, *tiPR, *clL, *clR, *clP;
+	CLFlt			likeL, likeR, *clL, *clR, *clP;
+	CLFlt2                  *pL, *pR, *tiPL, *tiPR;
 	ModelInfo		*m;
 	
 	/* find model settings for this division and nStates, nStatesSquared */
@@ -4291,7 +4435,8 @@
 
 {
 	int				c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL;
-	CLFlt			*clL, *clR, *clP, *pL, *pR, *tiPL, *tiPR;
+	CLFlt			*clL, *clR, *clP;
+	CLFlt2                  *pL, *pR, *tiPL, *tiPR;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -4446,7 +4591,7 @@
 
 
 
-
+/* NOTE: CLFlt, CLFlt2 assumptions made in below! - Allen */
 
 #if defined SSE
 /*----------------------------------------------------------------
@@ -4532,7 +4677,8 @@
 {
 
 	int				a, b, c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL, nStates, nStatesSquared;
-	CLFlt			likeL, likeR, *pL, *pR, *tiPL, *tiPR, *clL, *clR, *clP;
+	CLFlt			likeL, likeR, *clL, *clR, *clP;
+	CLFlt2                  *pL, *pR, *tiPL, *tiPR;
 	ModelInfo		*m;
 	
 	/* find model settings for this division and nStates, nStatesSquared */
@@ -4693,7 +4839,8 @@
 {
 
 	int				a, c, h, i, j, k, nStates, nCats;
-	CLFlt			*clL, *clR, *clP, *pL, *pR, *tiPL, *tiPR, likeL, likeR;
+	CLFlt			*clL, *clR, *clP, likeL, likeR;
+	CLFlt2                  *pL, *pR, *tiPL, *tiPR;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -4761,7 +4908,8 @@
 {
 
 	int				c, k;
-	CLFlt			*clL, *clR, *clP, *clA, *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
+	CLFlt			*clL, *clR, *clP, *clA;
+	CLFlt2                  *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
 	ModelInfo		*m;
 
 	/* find model settings for this division */
@@ -4823,8 +4971,8 @@
 
 	int				a, b, c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL, *aState=NULL,
 					catStart, nObsStates, nStates, nStatesSquared, preLikeJump;
-	CLFlt			likeL, likeR, likeA, *clL, *clR, *clP, *clA, *pL, *pR, *pA,
-					*tiPL, *tiPR, *tiPA;
+	CLFlt			likeL, likeR, likeA, *clL, *clR, *clP, *clA;
+	CLFlt2                  *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division and nStates, nStatesSquared */
@@ -5057,7 +5205,8 @@
 
 {
 	int				c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL, *aState=NULL;
-	CLFlt			*clL, *clR, *clP, *clA, *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
+	CLFlt			*clL, *clR, *clP, *clA;
+	CLFlt2                  *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -5270,7 +5419,7 @@
 
 
 
-
+/* NOTE ASSUMPTIONS REGARDING CLFlt, CLFlt2 -Allen */
 
 #if defined SSE
 /*----------------------------------------------------------------
@@ -5371,10 +5520,11 @@
 
 {
 
-	int				a, b, c, h, i, j, k, shortCut, *lState=NULL, *rState=NULL, *aState=NULL,
-					nStates, nStatesSquared;
-	CLFlt			likeL, likeR, likeA, *clL, *clR, *clP, *clA, *pL, *pR, *pA,
-					*tiPL, *tiPR, *tiPA;
+        int			a, b, c, h, i, j, k, shortCut, nStates, nStatesSquared;
+	int                     *lState=NULL, *rState=NULL, *aState=NULL;
+					
+	CLFlt			likeL, likeR, likeA, *clL, *clR, *clP, *clA;
+	CLFlt2                  *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division and nStates, nStatesSquared */
@@ -5576,8 +5726,8 @@
 {
 
 	int				a, c, h, i, j, k, nStates, nCats;
-	CLFlt			*clL, *clR, *clP, *clA, *pL, *pR, *pA, *tiPL, *tiPR, *tiPA,
-					likeL, likeR, likeA;
+	CLFlt			*clL, *clR, *clP, *clA, likeL, likeR, likeA;
+	CLFlt2                  *pL, *pR, *pA, *tiPL, *tiPR, *tiPA;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -5649,7 +5799,8 @@
 {
 
 	int				c, k;
-	CLFlt			*clFA, *clFP, *clDP, *pA, *tiPA, likeUp[2];
+	CLFlt			*clFA, *clFP, *clDP, likeUp[2];
+	CLFlt2                  *pA, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division */
@@ -5717,7 +5868,8 @@
 {
 
 	int				a, c, i, j, k, nStates, nStatesSquared, nGammaCats;
-	CLFlt			*clFA, *clFP, *clDP, *pA, *tiPA, *likeUp, sum;
+	CLFlt			*clFA, *clFP, *clDP, *likeUp, sum;
+	CLFlt2                  *pA, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division */
@@ -5810,7 +5962,8 @@
 {
 
 	int				c, k, nGammaCats;
-	CLFlt			*clFA, *clFP, *clDP, *pA, *tiPA, likeUp[4];
+	CLFlt			*clFA, *clFP, *clDP, likeUp[4];
+	CLFlt2                  *pA, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division */
@@ -5891,7 +6044,8 @@
 {
 
 	int				a, c, i, j, k, nStates, nCats;
-	CLFlt			*clFA, *clFP, *clDP, *pA, *tiPA, likeUp[10], sum;
+	CLFlt			*clFA, *clFP, *clDP, likeUp[10], sum;
+	CLFlt2                  *pA, *tiPA;
 	ModelInfo		*m;
 	
 	/* find model settings for this division */
@@ -6038,12 +6192,11 @@
 |		variation
 |
 -----------------------------------------------------------------*/
-int CondLikeScaler_Gen (TreeNode *p, int division, int chain)
-
+int CondLikeScaler_Gen (TreeNode *p, int division, int chain, int do_full_scaling)
 {
 
-	int				c, i, j, k, n, nStates;
-	CLFlt			scaler, *clP, *scPNew, *scPOld, *lnScaler;
+	int				c, i, j, k, n, nStates, doing_full_scaling;
+	CLFlt			scaler, *clP, *scP, *lnScaler, oldLnScaler;
 	ModelInfo		*m;
 
 	m = &modelSettings[division];
@@ -6052,8 +6205,7 @@
 	/* find conditional likelihood pointer */
 	clP = condLikePtr[chain][p->index] + m->condLikeStart + Bit(division, &p->clSpace[0]) * condLikeRowSize;
 
-	scPNew = nodeScaler[chain] + m->compCharStart + (2 * (p->index - numLocalTaxa) +  Bit(division, &p->clSpace[0]   )) * numCompressedChars;
-	scPOld = nodeScaler[chain] + m->compCharStart + (2 * (p->index - numLocalTaxa) + (Bit(division, &p->clSpace[0])^1)) * numCompressedChars;
+	scP = nodeScaler[chain] + m->compCharStart + ((2*(p->index - numLocalTaxa)) + state[chain]) * numCompressedChars;
 
 	lnScaler = treeScaler[chain] + m->compCharStart + state[chain] * numCompressedChars;
 
@@ -6060,34 +6212,121 @@
 	/* subtract old values; these can also be associated with old scaler nodes */
 	if (Bit(division, &p->scalersSet[0]) == 1)
 		{
-		for (c=0; c<m->numChars; c++)
-			lnScaler[c] -= scPOld[c];	/*subtract old value */
+		  for (c=0; c<m->numChars; c++) {
+		    oldLnScaler = lnScaler[c];
+		    if ((lnScaler[c] > LOG_CL_WARN_THRESH) &&
+			(num_times_scaler_warn3 < MAX_TIMES_SCALER_WARN3)) {
+		      MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d node %d scP is %1.30lf and lnScaler is (before subtracting scP) %1.30lf (numGammaCats is %d, nStates is %d)\n",
+				   spacer, division, division+1, c, p->index, scP[c], lnScaler[c],
+				   m->numGammaCats, nStates);
+		      num_times_scaler_warn3++;
+		      if (num_times_scaler_warn3 >= MAX_TIMES_SCALER_WARN3) {
+			MrBayesPrint("%s   WARNING: not warning again on scaler (3) until after next likelihood print\n",spacer);
+		      }
+		    }
+		    lnScaler[c] -= scP[c];	/*subtract old value */
+		    if (lnScaler[c] > LOG_CL_WARN_THRESH) {
+		      num_times_scaler_adjusted2++;
+		      if (((oldLnScaler > 0.0) ||
+			   (scP[c] > 0.0) ||
+			   (lnScaler[c] > (-0.01*(oldLnScaler+scP[c]))))) {
+			num_times_scaler_adjusted2_big++;
+			if (num_times_scaler_warn4 < MAX_TIMES_SCALER_WARN4) {
+			  MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d node %d scP is %1.30lf and lnScaler is %1.30lf before subtracting scP, %1.30lf after subtracting scP (numGammaCats is %d, nStates is %d); adjusting to 0.0\n",
+				       spacer, division, division+1, c, p->index, scP[c], oldLnScaler,
+				       lnScaler[c], m->numGammaCats, nStates);
+			  num_times_scaler_warn4++;
+			  if (num_times_scaler_warn4 >= MAX_TIMES_SCALER_WARN4) {
+			    MrBayesPrint("%s   WARNING: not warning again on scaler (4) reduction\n",spacer);
+			  }
+			}
+		      }
+		      lnScaler[c] = (CLFlt) 0.0;
+		    }
+		    scP[c] = (CLFlt) 0.0;
+		  }
 		FlipOneBit(division, &p->scalersSet[0]);
 		}
 
-	/* add new values only if currently a scaler node */
+#if defined(ALTSCALING)
+	if ((p->left == NULL) || (! do_full_scaling))
+	  doing_full_scaling = 0;
+	else {
+	  doing_full_scaling = 1;
+	  did_scaling = 1;
+	}
+#else
 	if (p->scalerNode == YES)
-		{
+	  doing_full_scaling = 1;
+	else
+	  doing_full_scaling = 0;
+#endif
+	/* add new values only if currently a scaler node */
+	if (doing_full_scaling) {
 		i = j = 0;
-		for (c=0; c<m->numChars; c++)
-			{
+		for (c=0; c<m->numChars; c++) {
 			scaler = 0.0;
 			for (k=0; k<m->numGammaCats; k++)
 				{
-				for (n=0; n<nStates; n++)
-					{
-					if (clP[i] > scaler)
+				  for (n=0; n<nStates; n++) {
+				    if (clP[i] > scaler) {
+				      if ((clP[i] > CL_WARN_THRESH3) &&
+					  (num_times_cl_warn < MAX_TIMES_CL_WARN) &&
+					  ((lnScaler[c]+log(clP[i])) > SCALER_WARN_THRESH)) { /* Allen */
+					MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d node %d GammaCat %d state %d clP is %1.30lf (numGammaCats is %d, nStates is %d, i is %d, scaler was %1.30lf, lnScaler was %1.30lf)\n",
+						     spacer, division, division+1, c, p->index, k, n, clP[i],
+						     m->numGammaCats, nStates, i, scaler, lnScaler[c]);
+					num_times_cl_warn++;
+					if (num_times_cl_warn >= MAX_TIMES_CL_WARN) {
+					  MrBayesPrint("%s   WARNING: not warning again on clP\n",spacer);
+					}
+				      }
 						scaler = clP[i];
+				    }
 					i++;
 					}
 				}
+#if defined(DEBUG_SCALER_NAN)
+			if ((! (isfinite(scaler))) || (scaler < (CLFlt)(1/(m->numGammaCats*nStates))))
+			  MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d scaler is %1.30lf (numGammaCats is %d, nStates is %d, lnScaler was %1.30lf)\n",
+				       spacer, division, division+1, c, scaler, m->numGammaCats, nStates, lnScaler[c]);
+#endif
 			for (k=0; k<m->numGammaCats; k++)
 				{
 				for (n=0; n<nStates; n++)
 					clP[j++] /= scaler;
 				}
-			scPNew[c] = (CLFlt) log (scaler);	/* store scaler       */
-			lnScaler[c] += scPNew[c];	/* add to site scaler */
+			scP[c] = (CLFlt) log (scaler);	/* store scaler       */
+			if ((lnScaler[c] > LOG_CL_WARN_THRESH) &&
+			    (num_times_scaler_warn2 < MAX_TIMES_SCALER_WARN2)) {
+			  MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d node %d scaler is %1.30lf, scP is %1.30lf, and lnScaler is (before adding scP) %1.30lf (numGammaCats is %d, nStates is %d)\n",
+				       spacer, division, division+1, c, p->index, scaler, scP[c], lnScaler[c],
+				       m->numGammaCats, nStates);
+			  num_times_scaler_warn2++;
+			  if (num_times_scaler_warn2 >= MAX_TIMES_SCALER_WARN2) {
+			    MrBayesPrint("%s   WARNING: not warning again on scaler (2)\n",spacer);
+			  }
+			}
+			lnScaler[c] += scP[c];	/* add to site scaler */
+			if (((scP[c] > 0.0) && (lnScaler[c] > LIKE_EPSILON)) ||
+			    (lnScaler[c] > LOG_CL_WARN_THRESH)) { /* Allen */
+			  num_times_scaler_adjusted++;
+			  if ((lnScaler[c] > LOG_CL_WARN_THRESH) &&
+			      (scaler > CL_WARN_THRESH)) {
+			    num_times_scaler_adjusted_big++;
+			    if (num_times_scaler_warn < MAX_TIMES_SCALER_WARN) {
+			      MrBayesPrint("%s   WARNING: for division %d (partition %d) char %d node %d scaler is %1.30lf, scP is %1.30lf, and lnScaler is %1.30lf (numGammaCats is %d, nStates is %d); reducing lnScaler to %1.6lf\n",
+					   spacer, division, division+1, c, p->index, scaler, scP[c], lnScaler[c],
+					   m->numGammaCats, nStates, (CLFlt) 0.0);
+			      num_times_scaler_warn++;
+			      if (num_times_scaler_warn >= MAX_TIMES_SCALER_WARN) {
+				MrBayesPrint("%s   WARNING: not warning again on scaler reduction\n",spacer);
+			      }
+			    }
+			  }
+			  scP[c] -= lnScaler[c];
+			  lnScaler[c] = (CLFlt) 0.0;
+			}
 			}
 		FlipOneBit(division, &p->scalersSet[0]);
 		}
@@ -6107,10 +6346,10 @@
 |		variation
 |
 -----------------------------------------------------------------*/
-int CondLikeScaler_NUC4 (TreeNode *p, int division, int chain)
+int CondLikeScaler_NUC4 (TreeNode *p, int division, int chain, int do_full_scaling)
 
 {
-	int				c, i, j, k;
+	int				c, i, j, k, doing_full_scaling;
 	CLFlt			scaler, *clP, *scPNew, *scPOld, *lnScaler;
 	ModelInfo		*m;
 	
@@ -6132,8 +6371,22 @@
 		FlipOneBit(division,&p->scalersSet[0]);	/* clear flag marking scalers set */
 		}
 
-	/* multiply by new values only if currently a scaler node */
+#if defined(ALTSCALING)
+	if ((p->left == NULL) || (! do_full_scaling))
+	  doing_full_scaling = 0;
+	else {
+	  doing_full_scaling = 1;
+	  did_scaling = 1;
+	}
+#else
 	if (p->scalerNode == YES)
+	  doing_full_scaling = 1;
+	else
+	  doing_full_scaling = 0;
+#endif
+
+	/* multiply by new values only if currently a scaler node */
+	if (doing_full_scaling)
 		{
 		i = j = 0;
 		for (c=0; c<m->numChars; c++)
